<?php
/**
 * @version $Id$
 * @package Advanced Cookies
 * @copyright Copyright (C) 2020 HOB-France.com, All rights reserved.
 * @license http://www.gnu.org/licenses GNU/GPL
 * @author url: https://www.hob-france.com/
 * @author email info@hob-fr.com
 * @developer Mihaly Varga - michel.varga@hob-fr.com
 *
 */
// no direct access
defined('_JEXEC') or die('Restricted access');
require_once (dirname(__FILE__).DIRECTORY_SEPARATOR.'helper.php');


$app = JFactory::getApplication();
$document = JFactory::getDocument();
JHtml::_('jquery.framework');
JHtml::_('script', 'system/core.js', false, true);

$modulePath = JURI::base() . 'media/mod_advanced_cookies/';
$moduleclass_sfx = htmlspecialchars($params->get('moduleclass_sfx'), ENT_COMPAT, 'UTF-8');
$extName = "HOBADVCOOKIES";

//Adding JS Files
$document->addScript($modulePath.'js/hobrgpdscript.js');

//Adding CSS Files
$document->addStyleSheet($modulePath.'css/style_front-end.css');


$service = ModAdvancedCookiesHelper::getServices($params);
$position = ModAdvancedCookiesHelper::getPosition($params);
$expiration = ModAdvancedCookiesHelper::getExpiration($params);
$text = ModAdvancedCookiesHelper::getText($params);
$switcher = ModAdvancedCookiesHelper::getSwitcher($params);
$collapse = ModAdvancedCookiesHelper::getCollapseText($params);
$bannerLinkUrl = ModAdvancedCookiesHelper::getUrl($params);
$cookie_category = ModAdvancedCookiesHelper::getCookieDescription($params);
$session_option = ModAdvancedCookiesHelper::getSessionOption($params);
$getvalidation = ModAdvancedCookiesHelper::getValidationKey($params);
$tServicesStates = ModAdvancedCookiesHelper::getServicesTabsState($params);
$setValidation = ModAdvancedCookiesHelper::infos_licence($extName ,$getvalidation['email']);
$license_activation = ModAdvancedCookiesHelper::getLicenceActivation($params);
$hob = ModAdvancedCookiesHelper::hob();
$cookie_btn = ModAdvancedCookiesHelper::getCookieBtnSettings($params);
$cookie_btn_display_mode = $params->get('cookie_button_show_hide');
//
////Send the arrays in the javascript file
$document->addScriptOptions('hobrgpdparams', $switcher);
$document->addScriptOptions('hobrgpdexpiration',$expiration);
$document->addScriptOptions('cookie_validation',$setValidation);
$document->addScriptOptions('service',$service);
//
//
////Banner style declaration
$document->addStyleDeclaration(ModAdvancedCookiesHelper::setPositionStyle($params));
$document->addStyleDeclaration(ModAdvancedCookiesHelper::setBannercolor($params));
$document->addStyleDeclaration(ModAdvancedCookiesHelper::setBannerTextcolor($params));
$document->addStyleDeclaration(ModAdvancedCookiesHelper::setBannerLinkTextcolor($params));
$document->addStyleDeclaration(ModAdvancedCookiesHelper::setCopyrightTextColor($params));
$document->addStyleDeclaration(ModAdvancedCookiesHelper::setcopyrigthLinkTextcolor($params));
$document->addStyleDeclaration(ModAdvancedCookiesHelper::setOkButtonStyle($params));
$document->addStyleDeclaration(ModAdvancedCookiesHelper::setDenyButtonStyle($params));
$document->addStyleDeclaration(ModAdvancedCookiesHelper::setSettingButtonStyle($params));
$document->addStyleDeclaration(ModAdvancedCookiesHelper::setSecondSettingButtonStyle($params));
$document->addStyleDeclaration(ModAdvancedCookiesHelper::setModalHeadcolor($params));
$document->addStyleDeclaration(ModAdvancedCookiesHelper::setModalHeadTextcolor($params));
$document->addStyleDeclaration(ModAdvancedCookiesHelper::setCookieBtnPosition($params));


//joomla let to look at the template file
require JModuleHelper::getLayoutPath('mod_advanced_cookies');
